package com.elephant.framework.galaxy.aroad.module.zhtj.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhtjGljsdjqk;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhyhZhzsGlData;
import com.elephant.framework.galaxy.aroad.module.zhtj.service.ZhtjGljsdjqkService;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;


/**
 * 综合统计_公路技术等级情况
 *
 * @author wangjian
 * @date 2019-03-11 17:24:55
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhtj/zhtjgljsdjqk")
public class ZhtjGljsdjqkController extends BaseController  {

  private final ZhtjGljsdjqkService zhtjGljsdjqkService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhtjGljsdjqk 综合统计_公路技术等级情况
   * @return
   */
  @GetMapping("/page")
  public R getZhtjGljsdjqkPage(Page page, ZhtjGljsdjqk zhtjGljsdjqk) {

    if(zhtjGljsdjqk!=null && zhtjGljsdjqk.getType().length()>15){
      String type = zhtjGljsdjqk.getType();
      zhtjGljsdjqk.setType(null);
      return  new R<>(zhtjGljsdjqkService.page(page,Wrappers.query(zhtjGljsdjqk).lambda().inSql(ZhtjGljsdjqk::getType,type)));
    }
    return  new R<>(zhtjGljsdjqkService.page(page,Wrappers.query(zhtjGljsdjqk)));
  }

  /**
   * 根据年份查询智慧养护综合展示公路数据
   * @param year 年份
   * @return
   */
  @GetMapping("/getZhyhZhzsGl")
  public R getZhyhZhzsGlData(String year) {
    return new R<>(zhtjGljsdjqkService.getZhyhZhzsGlData(year));
  }

  /**
   * 通过id查询综合统计_公路技术等级情况
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhtjGljsdjqkService.getById(id));
  }

  /**
   * 新增综合统计_公路技术等级情况
   * @param zhtjGljsdjqk 综合统计_公路技术等级情况
   * @return R
   */
  @SysLog("新增综合统计_公路技术等级情况")
  @PostMapping
  public R save(@RequestBody ZhtjGljsdjqk zhtjGljsdjqk){
    return new R<>(zhtjGljsdjqkService.save(zhtjGljsdjqk));
  }

  /**
   * 修改综合统计_公路技术等级情况
   * @param zhtjGljsdjqk 综合统计_公路技术等级情况
   * @return R
   */
  @SysLog("修改综合统计_公路技术等级情况")
  @PutMapping
  public R updateById(@RequestBody ZhtjGljsdjqk zhtjGljsdjqk){
    return new R<>(zhtjGljsdjqkService.updateById(zhtjGljsdjqk));
  }

  /**
   * 通过id删除综合统计_公路技术等级情况
   * @param id id
   * @return R
   */
  @SysLog("删除综合统计_公路技术等级情况")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhtjGljsdjqkService.removeById(id));
  }

  /**
   * 公路技术等级情况Echarts信息
   * @param year 年份
   * @return
   */
  @GetMapping("/chartinfo")
  public R getZhtjGljsdjqkztqkChartInfo(String year,String type) {
    System.out.print("year :"+year+", type: "+type);
    year = "2017";
    type = "总计";
    return  new R<>(zhtjGljsdjqkService.getZhtjGljsdjqkztqkEchartData(year,type));
  }
  /**
   *  获取全省公路技术等级、行政等级
   */
  @GetMapping("/qsgljsxz")
  public R getQsgljsxz(){
    return new R<>(zhtjGljsdjqkService.getQsgljsxz());
  }
}
